package agent;

public class NQueenProblem extends Problem {

    private int n;
    private int formulationKind;
    
    public NQueenProblem(int n, int formulationKind) {
        setN(n);
        setInitialState(new State(n));
        setFormulationKind(formulationKind);
    }
    
    public boolean goalTest(State state) {
        int[] variables = state.getVariables();
        
        if (variables.length == 0) {
            return false;
        }
        
        //todas as vari�veis tem valor?
        for (int i=0; i<variables.length; i++) {
            if (variables[i] == 0) {
                return false;
            }
        }
        
        //verifia��o de diagonais e linhas
        int increment;
        for (int i=0; i<variables.length; i++) {
            increment = 1;
            for (int j=i+1; j<variables.length; j++) {
                if ((variables[i] == variables[j] - increment) ||
                (variables[i] == variables[j]) ||
                (variables[i] == variables[j] + increment)) {
                    return false;
                }
                increment++;
            }
        }
        
        return true;
    }

    public int getN() {
        return n;
    }
    
    public void setN(int n) {
        this.n = n;
    }
    
    public int getFormulationKind() {
        return formulationKind;
    }
    
    public void setFormulationKind(int formulationKind) {
        this.formulationKind = formulationKind;
    }
}
