import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


import agent.*;
import agent.Action;

/*
 * a.java
 *
 * Created on May 8, 2003, 7:48 PM
 */

/**
 *
 * @author  nemaia
 */
public class NQueenSolver extends javax.swing.JFrame {
    
    public static int N_DEFAULT = 8;
    
    private int n;
    private int tipoFormulacao;
    private boolean[][] tabuleiro;
    private int[] estadoInicial;
    private NQueenSolverAgent agent;
    private Vector solucoesEncontradas;
    private Vector solucoesEncontradasTXT;
    
    /** Creates new form a */
    public NQueenSolver() {
        n = N_DEFAULT;
        tipoFormulacao = NQueenSolverAgent.N_QUEEN_INCREMENTAL;
        agent = new NQueenSolverAgent(n, tipoFormulacao);
        solucoesEncontradas = new Vector();
        solucoesEncontradasTXT = new Vector();
        SearchMethod.resetSteps();
        tabuleiro = new boolean[n][n];
        estadoInicial = new int[n];
        initComponents();
        initTabuleiro();
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        groupTipoFormulacao = new javax.swing.ButtonGroup();
        split = new javax.swing.JSplitPane();
        panelConteudo = new javax.swing.JPanel();
        scrollTabuleiro = new javax.swing.JScrollPane();
        panelTabuleiroGeral = new javax.swing.JPanel();
        panelTabuleiro = new javax.swing.JPanel();
        panelSolucoes = new javax.swing.JPanel();
        scrollSolucoes = new javax.swing.JScrollPane();
        listSolucoes = new javax.swing.JList();
        panelConfiguracoes = new javax.swing.JPanel();
        panelTipoFormulacao = new javax.swing.JPanel();
        comboTipoFormulacao = new javax.swing.JComboBox();
        jButton1 = new javax.swing.JButton();
        panelN = new javax.swing.JPanel();
        textFieldN = new javax.swing.JTextField();
        buttonMenos = new javax.swing.JButton();
        buttonMais = new javax.swing.JButton();
        panelBotoes = new javax.swing.JPanel();
        buttonIniciar = new javax.swing.JButton();
        buttonProxima = new javax.swing.JButton();
        buttonTodas = new javax.swing.JButton();
        panelPassos = new javax.swing.JPanel();
        labelPassos = new javax.swing.JLabel();
        panelQuantSolucoes = new javax.swing.JPanel();
        labelSolucoes = new javax.swing.JLabel();
        menu = new javax.swing.JMenuBar();
        menuNQueen = new javax.swing.JMenu();
        menuItemSobre = new javax.swing.JMenuItem();
        menuItemSair = new javax.swing.JMenuItem();

        setTitle("NQueen");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        split.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 1, 1, 1)));
        split.setOneTouchExpandable(true);
        panelConteudo.setLayout(new java.awt.GridBagLayout());

        panelConteudo.setBorder(new javax.swing.border.TitledBorder("Tabuleiro"));
        panelConteudo.setMinimumSize(new java.awt.Dimension(333, 347));
        scrollTabuleiro.setMaximumSize(new java.awt.Dimension(2147483647, 2147483647));
        scrollTabuleiro.setMinimumSize(new java.awt.Dimension(323, 323));
        scrollTabuleiro.setPreferredSize(new java.awt.Dimension(323, 323));
        panelTabuleiroGeral.setLayout(new java.awt.GridBagLayout());

        panelTabuleiroGeral.setMinimumSize(new java.awt.Dimension(320, 320));
        panelTabuleiro.setLayout(new java.awt.GridLayout(1, 0));

        panelTabuleiro.setMaximumSize(new java.awt.Dimension(2147483647, 2147483647));
        panelTabuleiro.setMinimumSize(new java.awt.Dimension(320, 320));
        panelTabuleiro.setPreferredSize(new java.awt.Dimension(320, 320));
        panelTabuleiro.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                posicionaRainha(evt);
            }
        });

        panelTabuleiroGeral.add(panelTabuleiro, new java.awt.GridBagConstraints());

        scrollTabuleiro.setViewportView(panelTabuleiroGeral);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        panelConteudo.add(scrollTabuleiro, gridBagConstraints);

        split.setLeftComponent(panelConteudo);

        panelSolucoes.setLayout(new java.awt.GridBagLayout());

        panelSolucoes.setBorder(new javax.swing.border.TitledBorder("Solu\u00e7\u00f5es"));
        panelSolucoes.setPreferredSize(new java.awt.Dimension(140, 155));
        scrollSolucoes.setPreferredSize(new java.awt.Dimension(150, 131));
        listSolucoes.setFont(new java.awt.Font("Courier", 1, 12));
        listSolucoes.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                mostraConfiguracao(evt);
            }
        });

        scrollSolucoes.setViewportView(listSolucoes);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        panelSolucoes.add(scrollSolucoes, gridBagConstraints);

        split.setRightComponent(panelSolucoes);

        getContentPane().add(split, java.awt.BorderLayout.CENTER);

        panelConfiguracoes.setLayout(new java.awt.GridBagLayout());

        panelConfiguracoes.setBorder(new javax.swing.border.TitledBorder("Configura\u00e7\u00f5es"));
        panelTipoFormulacao.setLayout(new java.awt.GridBagLayout());

        panelTipoFormulacao.setBorder(new javax.swing.border.TitledBorder("Tipo da Formula\u00e7\u00e3o"));
        comboTipoFormulacao.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Incremental", "Incremental rápida", "Estado inicial" }));
        comboTipoFormulacao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                alteraTipoFormulacao(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        panelTipoFormulacao.add(comboTipoFormulacao, gridBagConstraints);

        jButton1.setText("?");
        jButton1.setMargin(new java.awt.Insets(2, 4, 2, 4));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mostraExplicacao(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        panelTipoFormulacao.add(jButton1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        panelConfiguracoes.add(panelTipoFormulacao, gridBagConstraints);

        panelN.setLayout(new java.awt.GridBagLayout());

        panelN.setBorder(new javax.swing.border.TitledBorder("N"));
        textFieldN.setColumns(3);
        textFieldN.setText("8");
        textFieldN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                alteraN(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        panelN.add(textFieldN, gridBagConstraints);

        buttonMenos.setText("-");
        buttonMenos.setToolTipText("");
        buttonMenos.setMargin(new java.awt.Insets(2, 2, 2, 2));
        buttonMenos.setPreferredSize(new java.awt.Dimension(20, 19));
        buttonMenos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                decrementaN(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        panelN.add(buttonMenos, gridBagConstraints);

        buttonMais.setText("+");
        buttonMais.setToolTipText("");
        buttonMais.setMargin(new java.awt.Insets(2, 2, 2, 2));
        buttonMais.setPreferredSize(new java.awt.Dimension(20, 19));
        buttonMais.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                incrementaN(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        panelN.add(buttonMais, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.weighty = 1.0;
        panelConfiguracoes.add(panelN, gridBagConstraints);

        buttonIniciar.setMnemonic('i');
        buttonIniciar.setText("Limpar tudo");
        buttonIniciar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                limparTudo(evt);
            }
        });

        panelBotoes.add(buttonIniciar);

        buttonProxima.setMnemonic('p');
        buttonProxima.setText("Pr\u00f3xima solu\u00e7\u00e3o");
        buttonProxima.setToolTipText("Calcula a pr\u00f3xima solu\u00e7\u00e3o");
        buttonProxima.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                proximaSolucao(evt);
            }
        });

        panelBotoes.add(buttonProxima);

        buttonTodas.setMnemonic('t');
        buttonTodas.setText("Todas as solu\u00e7\u00f5es");
        buttonTodas.setToolTipText("Calcula todas as solu\u00e7\u00f5es");
        buttonTodas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                todasSolucoes(evt);
            }
        });

        panelBotoes.add(buttonTodas);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        panelConfiguracoes.add(panelBotoes, gridBagConstraints);

        panelPassos.setLayout(new java.awt.GridBagLayout());

        panelPassos.setBorder(new javax.swing.border.TitledBorder("Passos"));
        labelPassos.setPreferredSize(new java.awt.Dimension(60, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        panelPassos.add(labelPassos, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        panelConfiguracoes.add(panelPassos, gridBagConstraints);

        panelQuantSolucoes.setLayout(new java.awt.GridBagLayout());

        panelQuantSolucoes.setBorder(new javax.swing.border.TitledBorder("Resultados"));
        labelSolucoes.setPreferredSize(new java.awt.Dimension(60, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        panelQuantSolucoes.add(labelSolucoes, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        panelConfiguracoes.add(panelQuantSolucoes, gridBagConstraints);

        getContentPane().add(panelConfiguracoes, java.awt.BorderLayout.SOUTH);

        menuNQueen.setMnemonic('n');
        menuNQueen.setText("NQueen");
        menuItemSobre.setText("Sobre");
        menuItemSobre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sobre(evt);
            }
        });

        menuNQueen.add(menuItemSobre);
        menuItemSair.setText("Sair");
        menuItemSair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sair(evt);
            }
        });

        menuNQueen.add(menuItemSair);
        menu.add(menuNQueen);
        setJMenuBar(menu);

        pack();
    }//GEN-END:initComponents
    
    private void posicionaRainha(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_posicionaRainha
        if (tipoFormulacao == NQueenSolverAgent.N_QUEEN_COMPLETE_STATE) {
            int j = evt.getX() / 40;
            int i = evt.getY() / 40;
            for (int cont=0; cont<n; cont++) {
                if (tabuleiro[cont][j] && cont != i) {
                    JOptionPane.showMessageDialog(this, "Só é possível posicionar uma rainha em cada coluna!", "NQueen", JOptionPane.INFORMATION_MESSAGE);
                    return;
                }
            }
            estadoInicial[j] = i + 1;
            tabuleiro[i][j] = !tabuleiro[i][j];
            initTabuleiro();
        }
    }//GEN-LAST:event_posicionaRainha
    
    private void alteraTipoFormulacao(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_alteraTipoFormulacao
        if (comboTipoFormulacao.getSelectedItem().equals("Incremental")) {
            tipoFormulacao = NQueenSolverAgent.N_QUEEN_INCREMENTAL;
        } else if (comboTipoFormulacao.getSelectedItem().equals("Incremental rápida")) {
            tipoFormulacao = NQueenSolverAgent.N_QUEEN_QUICK_INCREMENTAL;
        } else if (comboTipoFormulacao.getSelectedItem().equals("Estado inicial")) {
            tipoFormulacao = NQueenSolverAgent.N_QUEEN_COMPLETE_STATE;
        }
        limparTudo(evt);
    }//GEN-LAST:event_alteraTipoFormulacao
    
    private void mostraExplicacao(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mostraExplicacao
        String msg = "";
        if (comboTipoFormulacao.getSelectedItem().equals("Incremental")) {
            msg = "Utilizando formulação incremental, as soluções são\ngeradas através do método de busca Forward Checking\n(most constrained variable).";
        } else if (comboTipoFormulacao.getSelectedItem().equals("Incremental rápida")) {
            msg = "Utilizando formulação incremental rápida, somente a\nprimeira solução é gerada, com um número mínimo de\npassos através do método de busca ForwardChecking\n(most constrained variable e least constraining value).";
        } else if (comboTipoFormulacao.getSelectedItem().equals("Estado inicial")) {
            msg = "Utilizando estado inicial, o usuário informa um estado\nqualquer e a solução é gerada pelo movimento de\nraínhas em conflito (Min-conflicts).";
        }
        JOptionPane.showMessageDialog(this, msg, "NQueen", JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_mostraExplicacao
    
    private void sair(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sair
        if (JOptionPane.showConfirmDialog(this, "Tem certeza que deseja sair?", "NQueen", JOptionPane.OK_CANCEL_OPTION)
        == JOptionPane.OK_OPTION) {
            System.exit(0);
        }
    }//GEN-LAST:event_sair
    
    private void sobre(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sobre
        JOptionPane.showMessageDialog(this, "....", "NQueen", JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_sobre
    
    private void alteraN(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_alteraN
        try {
            n = Integer.parseInt(textFieldN.getText());
            if (n <= 0) {
                n = N_DEFAULT;
                JOptionPane.showMessageDialog(this, "N inválido!", "NQueen", JOptionPane.ERROR_MESSAGE);
            }
        } catch (NumberFormatException nfe) {
            n = N_DEFAULT;
            JOptionPane.showMessageDialog(this, "N inválido!", "NQueen", JOptionPane.ERROR_MESSAGE);
        }
        textFieldN.setText(""+n);
        limparTudo(evt);
    }//GEN-LAST:event_alteraN
    
    private void mostraConfiguracao(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_mostraConfiguracao
        if (listSolucoes.getSelectedIndex() >= 0) {
            tabuleiro = new boolean[n][n];
            int[] solucao = (int[]) solucoesEncontradas.get(listSolucoes.getSelectedIndex());
            for (int i=0; i<solucao.length; i++) {
                tabuleiro[solucao[i]-1][i] = true;
            }
        }
        initTabuleiro();
    }//GEN-LAST:event_mostraConfiguracao
    
    private void proximaSolucao(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_proximaSolucao
        if (estadoInicialOK()) {
            Action[] sequenciaAcoes = agent.solve();
            if (sequenciaAcoes == null) {
                mostraBotoes(false);
            } else if (tipoFormulacao == NQueenSolverAgent.N_QUEEN_COMPLETE_STATE) {
                solucoesEncontradas.add(estadoInicial);
                solucoesEncontradasTXT.add("estado inicial");
                int[] estadoAtual = (int[]) estadoInicial.clone();
                for (int i=0; i<sequenciaAcoes.length; i++) {
                    estadoAtual[sequenciaAcoes[i].getVariable()] = sequenciaAcoes[i].getNewValue();
                    solucoesEncontradas.add((int[]) estadoAtual.clone());
                    solucoesEncontradasTXT.add(sequenciaAcoes[i]);
                }
                listSolucoes.setListData(solucoesEncontradasTXT);
                labelSolucoes.setText((solucoesEncontradas.size()-1)+"");
                mostraBotoes(false);
            } else {
                int[] solucao = new int[sequenciaAcoes.length];
                StringBuffer solucaoTXT = new StringBuffer();
                for (int i=0; i<sequenciaAcoes.length; i++) {
                    solucao[i] = sequenciaAcoes[i].getNewValue();
                    solucaoTXT.append(sequenciaAcoes[i].getNewValue() + " ");
                }
                solucoesEncontradas.add(solucao);
                solucoesEncontradasTXT.add(solucaoTXT.toString());
                listSolucoes.setListData(solucoesEncontradasTXT);
                listSolucoes.setSelectedIndex(solucoesEncontradasTXT.size()-1);
                labelSolucoes.setText(solucoesEncontradasTXT.size()+"");
                if (tipoFormulacao == NQueenSolverAgent.N_QUEEN_QUICK_INCREMENTAL) {
                    mostraBotoes(false);
                }
            }
            labelPassos.setText(SearchMethod.getNumberOfSteps()+"");
        }
    }//GEN-LAST:event_proximaSolucao
    
    private void todasSolucoes(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_todasSolucoes
        if (estadoInicialOK()) {
            Collection todasSolucoes = agent.getAllSolutions();
            Iterator iter = todasSolucoes.iterator();
            while (iter.hasNext()) {
                Action[] sequenciaAcoes = (Action[]) iter.next();
                if (sequenciaAcoes != null) {
                    StringBuffer solucaoTXT = new StringBuffer();
                    int[] solucao = new int[sequenciaAcoes.length];
                    for (int i=0; i<sequenciaAcoes.length; i++) {
                        solucao[i] = sequenciaAcoes[i].getNewValue();
                        solucaoTXT.append(sequenciaAcoes[i].getNewValue() + " ");
                    }
                    solucoesEncontradas.add(solucao);
                    solucoesEncontradasTXT.add(solucaoTXT.toString());
                }
            }
            listSolucoes.setListData(solucoesEncontradasTXT);
            listSolucoes.setSelectedIndex(solucoesEncontradasTXT.size()-1);
            labelSolucoes.setText(solucoesEncontradasTXT.size()+"");
            labelPassos.setText(SearchMethod.getNumberOfSteps()+"");
            
            mostraBotoes(false);
        }
    }//GEN-LAST:event_todasSolucoes
    
    private void incrementaN(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_incrementaN
        try {
            n = (Integer.parseInt(textFieldN.getText())) + 1;
        } catch (NumberFormatException nfe) {
            n = N_DEFAULT;
        }
        
        textFieldN.setText(""+n);
        
        //Atualiza botões
        limparTudo(evt);
    }//GEN-LAST:event_incrementaN
    
    private void decrementaN(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_decrementaN
        try {
            n = (Integer.parseInt(textFieldN.getText()));
            if (n>1) {
                n--;
            }
        } catch (NumberFormatException nfe) {
            n = N_DEFAULT;
        }
        textFieldN.setText(""+n);
        
        //Atualiza botões
        limparTudo(evt);
    }//GEN-LAST:event_decrementaN
    
    private void limparTudo(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_limparTudo
        
        //Limpa tabuleiro
        tabuleiro = new boolean[n][n];
        estadoInicial = new int[n];
        
        //Zera o número de passos
        SearchMethod.resetSteps();
        
        //Limpa quantidade de soluções
        labelSolucoes.setText("");
        labelPassos.setText("");
        
        //Limpa lista de soluções
        solucoesEncontradas = new Vector();
        solucoesEncontradasTXT = new Vector();
        listSolucoes.setListData(solucoesEncontradasTXT);
        
        //Atualiza botões
        mostraBotoes(true);
        
        agent = new NQueenSolverAgent(n, tipoFormulacao);
        initTabuleiro();
    }//GEN-LAST:event_limparTudo
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    private void mostraBotoes(boolean mostra) {
        if (mostra) {
            buttonProxima.setEnabled(true);
            if (tipoFormulacao == NQueenSolverAgent.N_QUEEN_INCREMENTAL) {
                buttonTodas.setEnabled(true);
            } else {
                buttonTodas.setEnabled(false);
            }
        } else {
            buttonProxima.setEnabled(false);
            buttonTodas.setEnabled(false);
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new NQueenSolver().show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel panelTabuleiro;
    private javax.swing.JPanel panelTipoFormulacao;
    private javax.swing.JMenuItem menuItemSair;
    private javax.swing.JButton buttonIniciar;
    private javax.swing.JLabel labelPassos;
    private javax.swing.JTextField textFieldN;
    private javax.swing.JPanel panelConfiguracoes;
    private javax.swing.JButton jButton1;
    private javax.swing.JPanel panelTabuleiroGeral;
    private javax.swing.JPanel panelBotoes;
    private javax.swing.JComboBox comboTipoFormulacao;
    private javax.swing.JLabel labelSolucoes;
    private javax.swing.JPanel panelSolucoes;
    private javax.swing.JPanel panelQuantSolucoes;
    private javax.swing.JMenu menuNQueen;
    private javax.swing.JMenuBar menu;
    private javax.swing.JList listSolucoes;
    private javax.swing.JMenuItem menuItemSobre;
    private javax.swing.JButton buttonMenos;
    private javax.swing.JPanel panelN;
    private javax.swing.JScrollPane scrollTabuleiro;
    private javax.swing.JSplitPane split;
    private javax.swing.JPanel panelConteudo;
    private javax.swing.ButtonGroup groupTipoFormulacao;
    private javax.swing.JPanel panelPassos;
    private javax.swing.JButton buttonMais;
    private javax.swing.JButton buttonProxima;
    private javax.swing.JScrollPane scrollSolucoes;
    private javax.swing.JButton buttonTodas;
    // End of variables declaration//GEN-END:variables
    
    private void initTabuleiro() {
        panelTabuleiro.removeAll();
        panelTabuleiro.setPreferredSize(new Dimension(n*40, n*40));
        panelTabuleiro.setMaximumSize(new Dimension(n*40, n*40));
        scrollTabuleiro.setPreferredSize(new Dimension(n*40 + 3, n*40 + 3));
        scrollTabuleiro.setMaximumSize(new Dimension(n*40, n*40));
        panelTabuleiro.setLayout(new GridLayout(n, n));
        JLabel casa = null;
        for (int i=0; i<n; i++) {
            for (int j=0; j<n; j++) {
                casa = new JLabel();
                casa.setIcon(geraImagem(i,j, tabuleiro[i][j]));
                panelTabuleiro.add(casa);
            }
        }
        show();
    }
    
    private ImageIcon geraImagem(int i, int j, boolean queen) {
        if ( (isEven(i) &&  isEven(j)) || (!isEven(i) && !isEven(j)) ) {
            if (queen) {
                return(new ImageIcon(getClass().getResource("/images/gray_queen.gif")));
            } else {
                return(new ImageIcon(getClass().getResource("/images/gray.gif")));
            }
        }
        else
            if (queen) {
                return(new ImageIcon(getClass().getResource("/images/white_queen.gif")));
            } else {
                return(new ImageIcon(getClass().getResource("/images/white.gif")));
            }
    }
    
    private boolean isEven(int x) {
        return (x == 2 * (x/2));
    }
    
    private boolean estadoInicialOK() {
        if (tipoFormulacao == NQueenSolverAgent.N_QUEEN_COMPLETE_STATE) {
            for (int i=0; i<estadoInicial.length; i++) {
                if (estadoInicial[i] == 0) {
                    JOptionPane.showMessageDialog(this, "Cada coluna do tabuleiro deve ter uma raínha!", "NQueen", JOptionPane.ERROR_MESSAGE);
                    return false;
                }
            }
            agent.setInitialState(new State(estadoInicial));
        }
        return true;
    }
}