package agent;

public class Node {
    private State state;
    private Node parentNode;
    //private Operator operator;
    private int depth;
    private Action[] actionSequence;
    
    public Node() {
        
    }

    public Node(State state) {
        setState(state);
    }
    
    /** Getter for property state.
     * @return Value of property state.
     */
    public State getState() {
        return state;
    }
    
    /** Setter for property state.
     * @param state New value of property state.
     */
    public void setState(State state) {
        this.state = state;
    }
    
    /** Getter for property parentNode.
     * @return Value of property parentNode.
     */
    public Node getParentNode() {
        return parentNode;
    }
    
    /** Setter for property parentNode.
     * @param parentNode New value of property parentNode.
     */
    public void setParentNode(Node parentNode) {
        this.parentNode = parentNode;
        setDepth(parentNode.getDepth() + 1);
    }
    
    /** Getter for property depth.
     * @return Value of property depth.
     */
    public int getDepth() {
        return depth;
    }
    
    /** Setter for property depth.
     * @param depth New value of property depth.
     */
    private void setDepth(int depth) {
        this.depth = depth;
    }

    private Action[] generateActionSequence() {
        int[] variables = state.getVariables();
        actionSequence = new Action[variables.length];
        for (int i=0; i<variables.length; i++) {
            actionSequence[i] = new Action(i, variables[i]);
        }
        return actionSequence;
    }
    
    /** Getter for property actionSequence.
     * @return Value of property actionSequence.
     */
    public Action[] getActionSequence() {
        if (actionSequence == null) {
            generateActionSequence();
        }
        return this.actionSequence;
    }
    
    /** Setter for property actionSequence.
     * @param actionSequence New value of property actionSequence.
     */
    public void setActionSequence(Action[] actionSequence) {
        this.actionSequence = actionSequence;
    }
    
    public String toString() {
        return state.toString();
    }
}
