package agent;

import queue.*;
import java.util.*;

public abstract class SearchMethod {
    
    public static int numberOfSteps = 0;    
    
    private Queue nodes;
    private Problem problem;

    public SearchMethod() {
        nodes = new Queue();
    }

    protected abstract Collection expand(Node node);
    
    public Action[] search(Problem problem) {
        setProblem(problem);
        Node node = new Node(problem.getInitialState());
        nodes.insertElementsFront(expand(node));
        while (!nodes.isEmpty()) {
            node = (Node) nodes.removeFront();
            incrementSteps();
            if (problem.goalTest(node.getState())) {
                problem.setInitialState(node.getState());
                return node.getActionSequence();
            }
            nodes.insertElementsFront(expand(node));
        }
        return null;
    }
    
    /** Getter for property problem.
     * @return Value of property problem.
     */
    public agent.Problem getProblem() {
        return problem;
    }
    
    /** Setter for property problem.
     * @param problem New value of property problem.
     */
    public void setProblem(Problem problem) {
        this.problem = problem;
    }

    public static void incrementSteps() {
        numberOfSteps++;
    }
    
    public static void resetSteps() {
        numberOfSteps = 0;
    }
    
    public static int getNumberOfSteps() {
        return numberOfSteps;
    }

}
